﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;

namespace SucheInDatei
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        int[] SucheInDatei(string dateiname, string suchtext)
        {
            char[] puffer = new char[100];
            if (suchtext.Length > puffer.Length)
            {
                throw new ApplicationException("Suchtext zu lang");
            }

            //TO DO: Exception Handling!!
            StreamReader sr = new StreamReader(dateiname);
            List<int> fundstellen = new List<int>();
            int nummerZeichenPufferanfang = 0;
            string s = "";
            while (!sr.EndOfStream)
            {
                int anzahlGelesen = sr.Read(puffer, 0, puffer.Length - s.Length);
                s = s + new string(puffer, 0, anzahlGelesen);
                int zahlZeichenVorher = s.Length;
                int stelleImPuffer = s.IndexOf(suchtext);
                if (stelleImPuffer >= 0)
                {
                    fundstellen.Add(nummerZeichenPufferanfang + stelleImPuffer);
                    s = s.Substring(stelleImPuffer + suchtext.Length, s.Length - stelleImPuffer - suchtext.Length);
                }
                else
                {
                    s = s.Substring(s.Length - suchtext.Length + 1, suchtext.Length - 1);
                }
                nummerZeichenPufferanfang += zahlZeichenVorher - s.Length;
            }
            sr.Close();
            return fundstellen.ToArray();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            int[] z = SucheInDatei(@"C:\Users\lovi\Desktop\Kritik_der_reinen_Vernunft_2_utf8.txt", "test");
                //@"C:\Users\lovi\Desktop\test.txt", "test");
        }
    }
}
